var id_SOF_GetVersion              	 = 0 ;
var id_SOF_SetSignMethod	    	 = 1 ;
var id_SOF_GetSignMethod	    	 = 2 ;
var id_SOF_SetEncryptMethod	    	 = 3 ;
var id_SOF_GetEncryptMethod	    	 = 4 ;
var id_SOF_GetUserList		    	 = 5 ;
var id_SOF_ExportUserCert	    	 = 6 ;
var id_SOF_Login		    		 = 7 ;
var id_SOF_GetPinRetryCount	    	 = 8 ;
var id_SOF_ChangePassWd	    		 = 9 ;
var id_SOF_ExportExChangeUserCert  	 = 10;
var id_SOF_GetCertInfo		    	 = 11;
var id_SOF_GetCertInfoByOid	    	 = 12;
var id_SOF_GetDeviceInfo	    	 = 13;
var id_SOF_ValidateCert	    		 = 14;
var id_SOF_SignData		    		 = 15;
var id_SOF_VerifySignedData	    	 = 16;
var id_SOF_SignFile		    		 = 17;
var id_SOF_VerifySignedFile	    	 = 18;
var id_SOF_EncryptData		    	 = 19;
var id_SOF_DecryptData		    	 = 20;
var id_SOF_EncryptFile		    	 = 21;
var id_SOF_DecryptFile		    	 = 22;
var id_SOF_SignMessage		    	 = 23;
var id_SOF_VerifySignedMessage	     = 24;
var id_SOF_GetInfoFromSignedMessage	 = 25;
var id_SOF_GenRandom		    	 = 26;
var id_SOF_HashFile		    		 = 27;
var id_SOF_ReadUsrDataFile	    	 = 28;
var id_SOF_WriteUsrDataFile	    	 = 29;
var id_SOF_SignDataXML		    	 = 30;
var id_SOF_VerifySignedDataXML	     = 31;
var id_SOF_GetXMLSignatureInfo	     = 32;
var id_SOF_ExtGMTspGetTime	    	 = 33;
var id_SOF_ExtGMTspSealTimeStamp   	 = 34;
var id_SOF_ExtGMTspVerifyTimeStamp 	 = 35;
var id_SOF_ExtControl		    	 = 36;
var id_SOF_ExtEnumDevice	    	 = 37;
var id_SOF_Finalize		    		 = 38;
var id_SOF_ExtSetEnvelopType	     = 39;
var id_SOF_ExtSymmEncryptFile	     = 40;
var id_SOF_ExtSymmDecryptFile	     = 41;
var id_SOF_ExtGetDeviceType	    	 = 42;
var id_SOF_Config		    		 = 43;
var id_SOF_ExtReadLabel              = 44;
var id_SOF_ExtIsLogin		    	 = 45;
var id_SOF_ExtLogout 		    	 = 46;
var id_SOF_ExtPKCS7SignFile	    	 = 47;
var id_SOF_ExtPKCS7VerifySignFile  	 = 48;
var id_SOF_ExtGetProductVersion    	 = 49;
var id_SOF_ExtBase64Encode           = 50;
var id_SOF_Ext_EnumFile           	 = 51;
var id_SOF_Ext_CreateFile            = 52;
var id_SOF_Ext_DeleteFile            = 53;
var id_SOF_Ext_ReadFile           	 = 54;
var id_SOF_Ext_WriteFile           	 = 55;
var id_SOF_Ext_GetFileAttribute      = 56;
var id_SOF_Ext_HashData      		 = 57;
var id_SOF_Initialize      		 	 = 58;

var _xmlhttps = [];  

var removeXDR = function(xdr) {
	var found = false;

	for ( i = 0; i < _xmlhttps.length; i++) {
	    if(_xmlhttps[i] == xdr){
		    found = true;
		    break;
	    }
	}
   
	if (found)
		_xmlhttps.splice(i, 1);
};
   
function GdcaPKIService() {
 	var _xmlhttp;
 	
	var _config = {
		host: 'localhost',		//服务地址
		port: '55661',			//服务端口
	    proto: 'http://'        //协议
	};

	var _isIE = false;
	var _IEVersion = 0;
	
	var _requrl = _config.proto+_config.host+':'+_config.port;
	
	this.base64Encode = function(val) {
	    var src = CryptoJS.enc.Utf8.parse(val);
		return CryptoJS.enc.Base64.stringify(src).toString();
	};
	
	this.base64Decode = function(val) {
	    var wa = CryptoJS.enc.Base64.parse(val);
		return CryptoJS.enc.Utf8.stringify(wa);
	};

	this.setHost = function(host) {
		_config.host = host;
		_requrl = _config.proto + _config.host + ':' + _config.port;
	};
	
	this.setProtocol = function(proto) {
		
		if(proto == PROTO_HTTP){
			_config.port = 55661;
			_config.proto = 'http://';
		}else if(proto == PROTO_HTTPS){
			_config.port = 55662;
			_config.proto = 'https://';
		}else
			return false;
		
		_requrl = _config.proto+_config.host+':'+_config.port;
		
		return true;
	};
	
    
    function AjaxIO(req_data, callback) {
		var xdr;

		_isIE = isIE();

		if(_IEVersion == 0 && _isIE)
			_IEVersion = IEVersion();
			
        if (_xmlhttp == null) {
            if (window.XMLHttpRequest) {
            	if(_IEVersion == 8 || _IEVersion == 9){
                	//_xmlhttp = new XDomainRequest();
            	}else  //for IE10+, Firefox, Chrome, Opera, Safari
                	_xmlhttp = new XMLHttpRequest();
            } else { //for IE7, IE6, IE5
                _xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
            }
        }
        
		if(_IEVersion == 8 || _IEVersion == 9)
			xdr = new XDomainRequest();

		if(callback != undefined){

			if(_IEVersion == 8 || _IEVersion == 9){
				xdr.ontimeout = function() {
					var obj = {"ErrorCode":SOF_ServiceTimeoutErr, "ErrorMsg":"操作超时A","Status": 0}
					callback(obj);
				};
				
			    xdr.onload = function(){
				    removeXDR(xdr);
                    try {
						var ret = JSON.parse(xdr.responseText);
						ret.ErrorCode = parseInt(ret.ErrorCode, 16);
						callback(ret);
                    } catch (e) {
						var obj = {"ErrorCode":SOF_ServiceErr, "ErrorMsg":"操作异常A","Status": 0}
						callback(obj);
                    }
                };
                
			    xdr.onerror = function(){
				    removeXDR(xdr);
					var obj = {"ErrorCode":SOF_ServiceErr,"ErrorMsg":"操作异常B","Status": 0}
					callback(obj);
                };

			}else{
				_xmlhttp.ontimeout = function() {
					var obj = {"ErrorCode":SOF_ServiceTimeoutErr, "ErrorMsg":"操作超时B","Status": 0}
					callback(obj);
				}
				
				_xmlhttp.onreadystatechange = function() {
						
					if (_xmlhttp.readyState == 4 ) {
						if(_xmlhttp.status === 200){
							var ret = JSON.parse(_xmlhttp.responseText);
							ret.ErrorCode = parseInt(ret.ErrorCode, 16);
							callback(ret);
						}else{
							console.log("_xmlhttp.readyState = " + _xmlhttp.readyState);
							console.log("_xmlhttp.status = " + _xmlhttp.status);
							console.log("_xmlhttp.statusText = " + _xmlhttp.statusText);
							var obj = {"ErrorCode":SOF_ServiceErr, "ErrorMsg":"操作失败, 请检查GDCA安全认证服务是否启动","Status": 0}
							callback(obj);
						}
					} else {

					}
				};
			}
		}
		
		try {
			if(_IEVersion == 8 || _IEVersion == 9){
				if(callback == undefined) {
					var obj = {"ErrorCode":SOR_NotSupportYetErr,"ErrorMsg":"IE8和IE9不支持同步调用","Status": 0}
					return obj;
				}

		        xdr.open("POST", _requrl);
				xdr.send(req_data);
				_xmlhttps.push(xdr);
			}else{
		        _xmlhttp.open("POST", _requrl, callback != undefined);
		        _xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");			
				_xmlhttp.send(req_data);
			}

			
		}catch(e){
			var obj = {"ErrorCode":SOF_ServiceErr,"ErrorMsg":"操作异常D","Status": 0}
			if(callback != undefined){
				callback(obj);
			}
			else
				return obj;
		}

		if(callback == undefined){

			if (_xmlhttp.readyState == 4 && _xmlhttp.status == 200) {
				var ret = JSON.parse(_xmlhttp.responseText);
				ret.ErrorCode = parseInt(ret.ErrorCode, 16);
				return ret;			
	        }
			else {
				console.log("_xmlhttp.readyState = " + _xmlhttp.readyState);
				console.log("_xmlhttp.status = " + _xmlhttp.status);
				console.log("_xmlhttp.statusText = " + _xmlhttp.statusText);
				var obj = {"ErrorCode":SOF_ServiceErr,"ErrorMsg":"操作异常E","Status": 0}
				return obj;
			}	
		}
    };

	//1.获取接口版本号
    this.SOF_GetVersion = function(callback) {
	   var request = {
		   funcid:id_SOF_GetVersion
	   };

	   return AjaxIO(JSON.stringify(request), callback);
    };

	//2.获取产品版本号
	this.SOF_Ext_GetProductVersion = function(product_type, callback) {
        var request = {
			 funcid:id_SOF_ExtGetProductVersion ,
			 productType :product_type	
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//3.全局设置
	this.SOF_Config = function(setType, setVal, callback) {
        var request = {
			funcid:id_SOF_Config,
			setType: setType,
			setVal: setVal
		};

		return AjaxIO(JSON.stringify(request), callback);
    };

	//5.枚举设备
    this.SOF_Ext_EnumDevice = function(callback) {
		var request = {
			 funcid:id_SOF_ExtEnumDevice ,	
		};
		return AjaxIO(JSON.stringify(request), callback);
    };

	//6.获取设备类型
	this.SOF_Ext_GetDeviceType = function(callback) {
		var request = {
			 funcid:id_SOF_ExtGetDeviceType ,	
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//7.枚举用户
    this.SOF_GetUserList = function(callback) {
	   var request = {
			 funcid:id_SOF_GetUserList,
			 ReturnMethod: 0,	
		};

		return AjaxIO(JSON.stringify(request), callback);
    };
	
	//8.获取设备信息
    this.SOF_GetDeviceInfo = function(SelectContainer, DevInfoType, callback) {
		var request = {
			funcid:id_SOF_GetDeviceInfo,
			ContainerName: SelectContainer,
			Type:DevInfoType
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//9.用户登录
    this.SOF_Login = function(SelectContainer,PassWd, callback) {
		var request = {
			funcid:id_SOF_Login,
			UserName: SelectContainer,
			PassWd: this.base64Encode(PassWd)
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//10.判断是否登录
	this.SOF_Ext_isLogin = function(containerName,loginType, callback) {
		var request = {
			funcid:id_SOF_ExtIsLogin,
			containerName: containerName,
			loginType: loginType
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//11.获取口令剩余次数
    this.SOF_GetPinRetryCount = function(container, callback) {
		var request = {
			funcid:id_SOF_GetPinRetryCount,
			ContainerName: container
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };
	
	//12.退出登录
    this.SOF_Ext_Logout = function(containerName,loginType, callback) {
		var request = {
			funcid:id_SOF_ExtLogout,
			containerName: containerName,
			loginType: loginType
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//13.修改密码
    this.SOF_ChangePassWd = function(ContainerName, OldPassWd, NewPassWd, callback) {
        var request = {
			funcid:id_SOF_ChangePassWd,
			ContainerName: ContainerName,
			OldPassWd: this.base64Encode(OldPassWd),
			NewPassWd: this.base64Encode(NewPassWd)
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//14.读取证书
	this.SOF_ExportUserCert = function(ContainerName, callback) {
		var request = {
			funcid:id_SOF_ExportUserCert,
			ContainerName: ContainerName,	
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//14.读取加密证书
	this.SOF_ExportExChangeUserCert = function(ContainerName, callback) {
		var request = {
			funcid:id_SOF_ExportExChangeUserCert,
			ContainerName: ContainerName,	
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//15.解析证书信息
    this.SOF_GetCertInfo = function(Cert, Type, callback) {
        var request = {
			funcid:id_SOF_GetCertInfo,
			Cert: Cert,
			Type: Type
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//16.解析证书信息（OID）
    this.SOF_GetCertInfoByOid = function(Base64EncodeCert, OID, callback) {
         var request = {
			funcid:id_SOF_GetCertInfoByOid,
			Cert: Base64EncodeCert,
			Oid: OID
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//17.证书验证
	 this.SOF_ValidateCert = function(Base64EncodeCert, callback) {
         var request = {
			funcid:id_SOF_ValidateCert,
			Cert: Base64EncodeCert
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//18.P1签名
    this.SOF_SignData = function(ContainerName,InData, callback) {
		var request = {
			funcid:id_SOF_SignData,
			ContainerName: ContainerName,
			InData: InData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//18.P1验签
    this.SOF_VerifySignedData = function(sign_cert, plain_data, signed_data, callback) {
		var request = {
			funcid:id_SOF_VerifySignedData,
			EncodeCert: sign_cert,
			InData: plain_data,
			SignValue: signed_data
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//20.P1文件签名
	this.SOF_SignFile = function(ContainerName, InFile, callback) {
		var request = {
			funcid:id_SOF_SignFile,
			ContainerName: ContainerName,
			SInFilePath: InFile
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };
	
	//20.P1文件验签
	this.SOF_VerifySignedFile = function(Base64EncodeCert, InData,SignedValue, callback) {
		var request = {
			funcid:id_SOF_VerifySignedFile,
			EncodeCert: Base64EncodeCert,
			InData: InData,
			SignValue: SignedValue
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//21.P7签名
    this.SOF_SignMessage = function(Flag,ContainerName,InData, callback) {
		var request = {
			funcid:id_SOF_SignMessage,
			Flag: Flag,
			ContainerName: ContainerName,
			InData: InData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//21.P7验签
    this.SOF_VerifySignedMessage = function(SignedData, OriginalText, callback) {
		var request = {
			funcid:id_SOF_VerifySignedMessage,
			MessageData: SignedData,
			InData: OriginalText
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//21.P7解析签名
    this.SOF_GetInfoFromSignedMessage = function(MessageData, Type, callback) {
		var request = {
			funcid:id_SOF_GetInfoFromSignedMessage,
			MessageData: MessageData,
			Type: Type
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//23.P7文件签名
    this.SOF_Ext_PKCS7_SignFile = function(ContainerName, InFile, SignFileFlag, callback) {
		var request = {
			funcid:id_SOF_ExtPKCS7SignFile,
			ContainerName: ContainerName,
			SInFilePath: InFile,
			SignFileFlag:SignFileFlag
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//23.P7文件验签
    this.SOF_Ext_PKCS7_VerifySignedFile = function(SignedData, InFilePath,SignFileFlag, callback) {
		var request = {
			funcid:id_SOF_ExtPKCS7VerifySignFile,
			MessageData: SignedData,
			SInFilePath: InFilePath,
			SignFileFlag:SignFileFlag
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//24.P7加解密设置格式
    this.SOF_Ext_SetEnvelopType = function(envType, callback) {
		var request = {
			funcid:id_SOF_ExtSetEnvelopType,
			envType: envType
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//24.p7加密
    this.SOF_EncryptData = function(Base64EncodeCert, InData, callback) {
		var request = {
			funcid:id_SOF_EncryptData,
			EncodeCert: Base64EncodeCert,
			InData: InData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//24.P7解密
    this.SOF_DecryptData = function(ContainerName,InData, callback) {
		var request = {
			funcid:id_SOF_DecryptData,
			ContainerName: ContainerName,
			InData: InData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//26 PKCS7文件加密
    this.SOF_EncryptFile = function(Cert, InFile, OutFile, callback) {
       	var request = {
			funcid: id_SOF_EncryptFile,
			EncodeCert: Cert,
			InFilePath: InFile,
			OutFilePath: OutFile
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//26 PKCS7文件解密
    this.SOF_DecryptFile = function(ContainerName, InFile, OutFile, callback) {
		var request = {
			funcid: id_SOF_DecryptFile,
			ContainerName: ContainerName,
			InFilePath: InFile,
			OutFilePath: OutFile
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//27.随机数
    this.SOF_GenRandom = function(length, callback) {
       var request = {
			funcid:id_SOF_GenRandom,
			Len: length
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

//28.读标签
    this.SOF_Ext_ReadLabel = function(containerName, lableName,lableType, callback) {
       var request = {
			funcid:id_SOF_ExtReadLabel,
			containerName: containerName,
			lableName: lableName,
			lableType: lableType
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//写读多用户数据
    this.SOF_Ext_WriteUsrDataFile = function(container,userpin,nFileType,nFileIndex,nFileOffset,sWriteData, callback) {
       var request = {
			funcid:id_SOF_WriteUsrDataFile,
			ContainerName: container,
			Pin: userpin,
			FileType: nFileType,
			FileIndex: nFileIndex,
			Offset: nFileOffset,
			WriteData: sWriteData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//读多用户数据
    this.SOF_Ext_ReadUsrDataFile = function(ContainerName,FileType,FileIndex,Offset,ReadLen, callback) {
       var request = {
			funcid:id_SOF_ReadUsrDataFile,
			ContainerName: ContainerName,
			FileType: FileType,
			FileIndex: FileIndex,
			Offset: Offset,
			ReadLen: ReadLen
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//文件HASH
	this.SOF_Ext_HashFile = function(hashAlg, InFile, pubKey, uid, callback) {
		var request = {
			funcid:id_SOF_HashFile,
			AlgorithmType: hashAlg,
			InFile: InFile,
			PublicKey: pubKey,
			ID: uid
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//XML签名
	this.SOF_SignDataXML = function(ContainerName,InData, callback) {
		var request = {
			funcid:id_SOF_SignDataXML,
			ContainerName: ContainerName,
			InData: InData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//XML验签
	this.SOF_VerifySignedDataXML = function(SignedData, callback) {
		var request = {
			funcid:id_SOF_VerifySignedDataXML,
			SignedData: SignedData
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//解析XML签名数据
	this.SOF_GetXMLSignatureInfo = function(SignedData,Type, callback) {
		var request = {
			funcid:id_SOF_GetXMLSignatureInfo,
			SignedData: SignedData,
			Type: Type
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//国密时间戳
	this.SOF_Ext_TspGetTime = function(callback) {
		var request = {
			funcid:id_SOF_ExtGMTspGetTime,
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//加盖时间戳
	this.SOF_Ext_TspGetStamp = function(InData,AlgType, callback) {
		var request = {
			funcid:id_SOF_ExtGMTspSealTimeStamp,
			InData: InData,
			AlgType: AlgType
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//验证时间戳
	this.SOF_Ext_TspVerifyStamp = function(InData,SealData,Cert, callback) {
		var request = {
			funcid:id_SOF_ExtGMTspVerifyTimeStamp,
			InData: InData,
			SealData: SealData,
			Cert: Cert
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };
	
	//接口控制
	this.SOF_Ext_Control = function(ContainerName,CtrlName,CtrlCmd, callback) {
		var request = {
			funcid:id_SOF_ExtControl,
			ContainerName: ContainerName,
			CtrlName: CtrlName,
			CtrlCmd: CtrlCmd
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//文件对称加密
	 this.SOF_Ext_SymmEncryptFile = function(symmAlg, symmKey, symmIV,inFilePath, outFilePath, callback) {
       var request = {
			funcid:id_SOF_ExtSymmEncryptFile,
			symmAlg: symmAlg,
			symmKey: symmKey,
			symmIV: symmIV,
			inFilePath: inFilePath,
			outFilePath: outFilePath
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };

	//文件对称解密
    this.SOF_Ext_SymmDecryptFile = function(symmAlg, symmKey, symmIV,inFilePath, outFilePath, callback) {
       var request = {
			funcid:id_SOF_ExtSymmDecryptFile,
			symmAlg: symmAlg,
			symmKey: symmKey,
			symmIV: symmIV,
			inFilePath: inFilePath,
			outFilePath: outFilePath
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };
	
    this.SOF_Ext_Base64Encode = function(InData, callback) {
        var request = {
            funcid:id_SOF_ExtBase64Encode,
            InData:InData
        };
        
        return AjaxIO(JSON.stringify(request), callback);
    };

    this.SOF_Ext_EnumFile = function(containerName, callback) {
        var request = {
            funcid:id_SOF_Ext_EnumFile,
            ContainerName:containerName
        };

		return AjaxIO(JSON.stringify(request), callback);
    };

    this.SOF_Ext_CreateFile = function(containerName, fileName, fileLen, readRights, writeRights, callback) {
        var request = {
            funcid:id_SOF_Ext_CreateFile,
			ContainerName: containerName,
			fileName: fileName,
			fileLen: fileLen,
			readRights: readRights,
			writeRights: writeRights
        };

		return AjaxIO(JSON.stringify(request), callback);
    };

    this.SOF_Ext_DeleteFile = function(containerName, fileName, callback) {
        var request = {
            funcid:id_SOF_Ext_DeleteFile,
            ContainerName:containerName,
            fileName: fileName
        };

		return AjaxIO(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_GetFileAttribute = function(containerName, fileName, callback) {
        var request = {
            funcid:id_SOF_Ext_GetFileAttribute,
            ContainerName:containerName,
            fileName: fileName
        };

		return AjaxIO(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_ReadFile = function(containerName, fileName, offset, readLen, callback) {
        var request = {
            funcid:id_SOF_Ext_ReadFile,
            ContainerName:containerName,
			fileName: fileName,
			offset: offset,
			readLen: readLen
        };

		return AjaxIO(JSON.stringify(request), callback);
    };

    this.SOF_Ext_WriteFile = function(containerName, fileName, offset, dataFmt, fileData, callback) {
        var request = {
            funcid:id_SOF_Ext_WriteFile,
			ContainerName: containerName,
			fileName: fileName,
			offset: offset,
			dataFmt: dataFmt,
			fileData: fileData
        };

		return AjaxIO(JSON.stringify(request), callback);
    };
    
    this.SOF_Ext_HashData = function(hashAlg, inData, inDataFmt, pubKey, uid, callback) {
        var request = {
            funcid:id_SOF_Ext_HashData,
			hashAlg: hashAlg,
			inData: inData,
			inDataFmt: inDataFmt,
			pubKey: pubKey,
			uid: uid
        };

		return AjaxIO(JSON.stringify(request), callback);
    };
    
	//清理
    this.SOF_Finalize = function(callback) {
       var request = {
			funcid:id_SOF_Finalize
		};
		
		return AjaxIO(JSON.stringify(request), callback);
    };
    
	this.Errcode2Msg = function(ec){
		var msg = '';
		
		switch (ec) 
		{
			case SOR_OK:
				msg = '成功';
			break;

			case SOR_UnknownErr:
				msg = '异常错误';
			break;

			case SOR_NotSupportYetErr:
				msg = '不支持的服务';
			break;

			case SOR_FileErr:
				msg = '文件操作错误';
			break;

			case SOR_ProviderTypeErr:
				msg = '服务提供者参数类型错误';
			break;

			case SOR_LoadProviderErr:
				msg = '导入服务提供者接口错误';
			break;

			case SOR_LoadDevMngApiErr:
				msg = '导入设备管理接口错误';
			break;

			case SOR_AlgoTypeErr:
				msg = '算法类型错误';
			break;

			case SOR_NameLenErr:
				msg = '名称长度错误';
			break;

			case SOR_KeyUsageErr:
				msg = '密钥用途错误';
			break;

			case SOR_ModulusLenErr:
				msg = '模的长度错误';
			break;

			case SOR_NotInitializeErr:
				msg = '未初始化';
			break;

			case SOR_ObjErr:
				msg = '对象错误';
			break;

			case SOR_MemoryErr:
				msg = '内存错误';
			break;

			case SOR_TimeoutErr:
				msg = '服务超时';
			break;

			case SOR_IndataLenErr:
				msg = '输入数据长度错误';
			break;

			case SOR_IndataErr:
				msg = '输入数据错误';
			break;

			case SOR_GenRandErr:
				msg = '生成随机数错误';
			break;

			case SOR_HashObjErr:
				msg = 'HASH对象错';
			break;

			case SOR_HashErr:
				msg = 'HASH运算错误';
			break;

			case SOR_GenRsaKeyErr:
				msg = '产生RSA密钥错';
			break;

			case SOR_RsaModulusLenErr:
				msg = 'RSA密钥模长错误';
			break;

			case SOR_CspImprtPubKeyErr:
				msg = 'CSP服务导入公钥错误';
			break;

			case SOR_RsaEncErr:
				msg = 'RSA加密错误';
			break;

			case SOR_RsaDecErr:
				msg = 'RSA解密错误';
			break;

			case SOR_HashNotEqualErr:
				msg = 'HASH值不相等';
			break;

			case SOR_KeyNotFountErr:
				msg = '密钥未发现';
			break;

			case SOR_CertNotFountErr:
				msg = '证书未发现';
			break;

			case SOR_NotExportErr:
				msg = '对象未导出';
			break;

			case SOR_VeryPolicyErr:
				msg = '未能完全按照策略验证成功宏描述预定义值说明';
			break;

			case SOR_DecryptPadErr:
				msg = '解密时做补丁错误';
			break;

			case SOR_MacLenErr:
				msg = 'MAC长度错误';
			break;

			case SOR_KeyInfoTypeErr:
				msg = '密钥类型错误';
			break;

			case SOR_NULLPointerErr:
				msg = '某一个参数为空指针';
			break;

			case SOR_APPNotFoundErr:
				msg = '没有找到该应用';
			break;

			case SOR_CERTENCODEErr:
				msg = '证书编码格式错误';
			break;

			case SOR_CERTINVALIDErr:
				msg = '证书无效,不是可信CA颁发的证书';
			break;

			case SOR_CERTHASEXPIREDErr:
				msg = '证书已过期';
			break;

			case SOR_CERTREVOKEDErr:
				msg = '证书已经被吊销';
			break;

			case SOR_SIGNDATAErr:
				msg = '签名失败';
			break;

			case SOR_VERIFYSIGNDATAErr:
				msg = '验证签名失败';
			break;

			case SOR_READFILEErr:
				msg = '读文件异常';
			break;

			case SOR_WRITEFILEErr:
				msg = '写文件异常';
			break;

			case SOR_SECRETSEGMENTErr:
				msg = '门限算法密钥分割失败';
			break;

			case SOR_SECERTRECOVERYErr:
				msg = '门限恢复失败';
			break;

			case SOR_ENCRYPTDATAErr:
				msg = '对数据的对称加密失败';
			break;

			case SOR_DECRYPTDATAErr:
				msg = '对称算法的数据解密失败';
			break;

			case SOR_PKCS7ENCODEErr:
				msg = 'PKCS7编码格式错误';
			break;

			case SOR_XMLENCODEErr:
				msg = '不是合法的xml编码数据';
			break;

			case SOR_PARAMETERNOTSUPPORTErr:
				msg = '不支持的参数';
			break;

			case SOR_CTLNOTFOUND:
				msg = '没有发现信任列表';
			break;

			case SOR_APPNOTFOUND:
				msg = '设置的应用名称没发现';
			break;

			case SOR_ECCEncErr:
				msg = 'ECC加密错误';
			break;

			case SOR_P7SignErr:
				msg = 'P7签名错误';
			break;

			case SOR_P7DecErr:
				msg = 'P7解密错误';
			break;

			case SOR_TSP_DataErr:
				msg = '时间戳服务器应答数据错误';
			break;

			case SOR_TSP_Err:
				msg = '时间戳服务器错误';
			break;

			case SOR_FileExistErr:
				msg = '文件已存在';
			break;

			case SOR_NotEnoughSpace:
				msg = '空间不足';
			break;

			case SOR_FileNotExistErr:
				msg = '文件不存在';
			break;

			case SOR_ReachMaxFileNum:
				msg = '已达到最大可创建文件数';
			break;

			case SOR_MUSpaceNotAllocErr:
				msg = '多用户空间未分配';
			break;

			case SOR_EnumDevErr:
				msg = '设备枚举错误';
			break;

			case SOR_CertNotYetValidErr:
				msg = '证书未生效';
			break;

			case SOR_CertFrozenErr:
				msg = '证书被冻结';
			break;
			
			case SOR_CAAuthErr:
				msg = 'CA认证失败';
			break;

			case SOR_NotLoginErr:
				msg = '未登录';
			break;
				
			case SOR_KeyPairNotMatchErr:
				msg = '公私钥不匹配';
			break;
			
			case SOR_MUNotLogin:
				msg = '多用户未登录';
			break;
			
			case SOR_WrongPinErr:
				msg = '错误的口令';
			break;
			
			case SOR_ContainerNotExistErr:
				msg = '的容器不存在';
			break;
			
			case SOR_CertParseErr:
				msg = '证书解析错误';
			break;
			
			case SOR_OIDInfoNotExist:
				msg = 'OID信息项不存在';
			break;
			
			case SAR_MsgParseErr:
				msg = '报文解析错误';
			break;
			
			case SAR_MsgParamErr:
				msg = '报文参数错误';
			break;
			
			case SAR_MsgBase64Err:
				msg = 'Base64编解码失败';
			break;
			
			default:
				msg = '未知错误';
				break;
		}

		return msg;
	};

}

var gPKISvc = new GdcaPKIService();